<?php
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup();

$sql = "SELECT user_id, post_id, 1 as rate, thanks_time as rate_time
	FROM `{$table_prefix}thanks`
	GROUP BY user_id, post_id, rate";
$rs = $db->sql_query($sql);

while ($row = $db->sql_fetchrow($rs))
{
	$post_id = $row['post_id'];
	$user_id = $row['user_id'];

	// Get current user rate
	$sql = 'SELECT *
		FROM ' . POST_RATES_TABLE . '
		WHERE user_id = ' . $user_id . '
			AND post_id = ' . $post_id;
	$result = $db->sql_query($sql);
	$user_rate = $db->sql_fetchrow($result);
	if ($user_rate) continue;
	$user_rate = array('rate' => $row['rate'], 'rate_time' => $row['rate_time']);

	// Get post
	$sql = 'SELECT p.*, t.topic_first_post_id
		FROM ' . POSTS_TABLE . ' p
		LEFT JOIN ' . TOPICS_TABLE . ' t ON t.topic_id = p.topic_id
		WHERE p.post_id = ' . $post_id;
	$result = $db->sql_query($sql);
	$post = $db->sql_fetchrow($result);
	if (!$post)
	{
		continue;
	}

	$sql = 'INSERT 
		INTO ' . POST_RATES_TABLE . '
		SET rate = ' . $user_rate['rate'] . ',
			rate_time = ' . $user_rate['rate_time'] . ',
			user_id = ' . $user_id . ',
			post_id = ' . $post_id;
	$db->sql_query($sql);

	// Update post rating
	$sql = 'SELECT rate, COUNT(*) as count
		FROM ' . POST_RATES_TABLE . '
		WHERE post_id = ' . $post_id . '
		GROUP BY rate';
	$result = $db->sql_query($sql);

	$post_rating_negative = 0;
	$post_rating_positive = 0;
	while ($row = $db->sql_fetchrow($result))
	{
		if ($row['rate'] < 0)
		{
			$post_rating_negative += abs($row['rate'] * $row['count']);
		}
		else
		{
			$post_rating_positive += abs($row['rate'] * $row['count']);
		}
	}

	$sql = 'UPDATE ' . POSTS_TABLE . '
		SET post_rating_positive = ' . $post_rating_positive . ',
			post_rating_negative = ' . $post_rating_negative . '
		WHERE post_id = ' . $post_id;
	$db->sql_query($sql);

	// Update poster rating
	$sql = 'SELECT rate, COUNT(*) as count
		FROM ' . POST_RATES_TABLE . ' r
		LEFT JOIN ' . POSTS_TABLE . ' p ON r.post_id = p.post_id
		WHERE p.poster_id = ' . $post['poster_id'] . '
		GROUP BY rate';
	$result = $db->sql_query($sql);

	$poster_rating_negative = 0;
	$poster_rating_positive = 0;
	while ($row = $db->sql_fetchrow($result))
	{
		if ($row['rate'] < 0)
		{
			$poster_rating_negative += abs($row['rate'] * $row['count']);
		}
		else
		{
			$poster_rating_positive += abs($row['rate'] * $row['count']);
		}
	}

	$sql = 'UPDATE ' . USERS_TABLE . '
		SET user_rating_positive = ' . $poster_rating_positive . ',
			user_rating_negative = ' . $poster_rating_negative . '
		WHERE user_id = ' . $post['poster_id'];
	$db->sql_query($sql);
	
	// Update rater info
	$sql = 'SELECT rate, COUNT(*) as count
		FROM ' . POST_RATES_TABLE . '
		WHERE user_id = ' . $user_id . '
		GROUP BY rate';
	$result = $db->sql_query($sql);

	$user_rated_negative = 0;
	$user_rated_positive = 0;
	while ($row = $db->sql_fetchrow($result))
	{
		if ($row['rate'] < 0)
		{
			$user_rated_negative += abs($row['rate'] * $row['count']);
		}
		else
		{
			$user_rated_positive += abs($row['rate'] * $row['count']);
		}
	}

	$sql = 'UPDATE ' . USERS_TABLE . '
		SET user_rated_positive = ' . $user_rated_positive . ',
			user_rated_negative = ' . $user_rated_negative . '
		WHERE user_id = ' . $user_id;
	$db->sql_query($sql);
}
echo "Finished";